"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = require("@babel/runtime/regenerator");

var _koaSend = require("koa-send");

var _common = _interopRequireWildcard(require("@srejs/common"), true);

var _webpack = require("@srejs/webpack");

var _sendHtml = require("./send-html");

var _render2 = require("./render");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Srejs = /*#__PURE__*/function () {
  /**
   *
   * @param {*} app koa实例对象
   * @param {*} dev 是否开发环境
   * @param {*} defaultRouter 是否使用默认文件路由
   * @param options 框架配置属性
   */
  function Srejs(app) {
    var dev = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    var defaultRouter = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

    _classCallCheck(this, Srejs);

    this.routes = [];
    this.app = app;

    if (dev) {
      process.env.NODE_ENV = 'development';
    } else {
      process.env.NODE_ENV = 'production';
    }

    this.dev = dev;
    this.options = _common["default"].setOptions(options);
    this.hmr();
    this.serverStatic();
    defaultRouter && this.usePageRouter();
  }

  _createClass(Srejs, [{
    key: "usePageRouter",
    value: function () {
      var _usePageRouter = _asyncToGenerator( /*#__PURE__*/_regenerator.mark(function _callee() {
        var _this = this;

        return _regenerator.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                (0, _webpack.getVueEntryList)().forEach(function (page) {
                  _this.addRouter(page);
                });
                this.app.use(this.middleware());

              case 2:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function usePageRouter() {
        return _usePageRouter.apply(this, arguments);
      }

      return usePageRouter;
    }()
  }, {
    key: "serverStatic",
    value: function serverStatic() {
      this.app.use( /*#__PURE__*/function () {
        var _ref = _asyncToGenerator( /*#__PURE__*/_regenerator.mark(function _callee2(ctx, next) {
          var staticStatus;
          return _regenerator.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  _context2.prev = 0;
                  _context2.next = 3;
                  return _koaSend(ctx, ctx.path, {
                    root: _common.clientDir,
                    setHeaders: function setHeaders(res) {
                      res.setHeader('Cache-Control', ['max-age=2592000']);
                    }
                  });

                case 3:
                  staticStatus = _context2.sent;
                  _context2.next = 9;
                  break;

                case 6:
                  _context2.prev = 6;
                  _context2.t0 = _context2["catch"](0);
                  return _context2.abrupt("return", next());

                case 9:
                  if (!(staticStatus == undefined)) {
                    _context2.next = 12;
                    break;
                  }

                  _context2.next = 12;
                  return next();

                case 12:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, null, [[0, 6]]);
        }));

        return function (_x, _x2) {
          return _ref.apply(this, arguments);
        };
      }());
    }
    /**
     * 注册默认路由
     * @param {*} page
     */

  }, {
    key: "addRouter",
    value: function addRouter(page) {
      var rePath = new RegExp('^/' + page + '(/?.*)'); // re为/^\d+bl$

      var prefixRouter = this.options.prefixRouter;

      if (prefixRouter != '') {
        rePath = new RegExp('^/' + prefixRouter + '/' + page + '(/?.*)'); // re为/^\d+bl$
      }

      _common.Logger.info("srejs: ".concat(rePath, "---->/").concat(page, "/").concat(page));

      this.routes.push(rePath);
    }
    /**
     * koa中间件拦截页面组件默认的路由，eg:web/pages/index/index.ts 映射为/index
     * @returns
     */

  }, {
    key: "middleware",
    value: function middleware() {
      var _this2 = this;

      var self = this;
      return /*#__PURE__*/function () {
        var _ref2 = _asyncToGenerator( /*#__PURE__*/_regenerator.mark(function _callee3(ctx, next) {
          var i, regRouter, document;
          return _regenerator.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  i = 0;

                case 1:
                  if (!(i < self.routes.length)) {
                    _context3.next = 15;
                    break;
                  }

                  regRouter = self.routes[i];

                  if (!regRouter.test(ctx.path)) {
                    _context3.next = 12;
                    break;
                  }

                  self.setContext(ctx);
                  _context3.next = 7;
                  return (0, _render2.render)(ctx);

                case 7:
                  document = _context3.sent;

                  if (document) {
                    _context3.next = 10;
                    break;
                  }

                  return _context3.abrupt("return", next());

                case 10:
                  _this2.renderHtml(ctx, document);

                  return _context3.abrupt("break", 15);

                case 12:
                  i++;
                  _context3.next = 1;
                  break;

                case 15:
                  _context3.next = 17;
                  return next();

                case 17:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3);
        }));

        return function (_x3, _x4) {
          return _ref2.apply(this, arguments);
        };
      }();
    }
    /**
     * 初始化koa请求上下文
     * @param {*} ctx
     * @param {*} viewName
     * @param {*} options
     */

  }, {
    key: "setContext",
    value: function setContext(ctx, viewName) {
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var prefixRouter = this.options.prefixRouter;
      ctx[_common.SSRKEY] = ctx[_common.SSRKEY] || {};
      ctx[_common.SSRKEY].options = Object.assign({}, this.options, options);
      var parseQ = (0, _common.parseQuery)(ctx);
      var page = parseQ.pathname.replace('/' + prefixRouter, '').replace(/^\//, '').split('/')[0];
      ctx[_common.SSRKEY].page = viewName || page;
      ctx[_common.SSRKEY].query = parseQ.query;
      ctx[_common.SSRKEY].path = ctx.path;
    }
    /**
     *
     * @param {*} ctx
     * @param {*} viewName  模板名称
     * @param {*} initProps 服务端初始化数据
     * @param {*} options
     */

  }, {
    key: "render",
    value: function () {
      var _render = _asyncToGenerator( /*#__PURE__*/_regenerator.mark(function _callee4(ctx, viewName, initProps, options) {
        var html;
        return _regenerator.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                this.setContext(ctx, viewName, options);
                _context4.next = 3;
                return (0, _render2.render)(ctx, initProps);

              case 3:
                html = _context4.sent;
                return _context4.abrupt("return", html);

              case 5:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function render(_x5, _x6, _x7, _x8) {
        return _render.apply(this, arguments);
      }

      return render;
    }()
    /**
     * 返回客户端ssr结果
     * @param {*} ctx
     * @param {*} html
     */

  }, {
    key: "renderHtml",
    value: function renderHtml(ctx, html) {
      (0, _sendHtml.sendHTML)(ctx, html, {
        generateEtags: true
      });
    }
    /**
     * 开发环境时HMR热更新
     */

  }, {
    key: "hmr",
    value: function hmr() {
      if (this.dev) {
        var page = process.argv.splice(2)[0] || true;
        new _webpack.VueHotWebpack(this.app, page);
        new _webpack.WebpackVue(page, true, true).run(); // 启动时只提取构建服务端所需资源
      }
    }
  }]);

  return Srejs;
}();

exports["default"] = Srejs;